<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\CardsService;

class CardsController extends FMCrud{
    protected $dataSourceName = 'fcm_checklistagend';
    protected $CardsService;
   
    public function __construct($crudService, $environment, CardsService $CardsService) {
        parent::__construct($crudService, $environment);
        $this->CardsService = $CardsService;
    }

    public function getTipoLocal(DTO\Request $request, DTO\Response $response) {
        $variavel = $this->CardsService->buscandoTipoLocal();
        $dtsVal = new DataSet('tipoLocal', $variavel);
        $response->addDataSet($dtsVal);
    }

    public function getLocal(DTO\Request $request, DTO\Response $response) {
        $variavel = $this->CardsService->buscandoLocal();
        $dtsVal = new DataSet('local', $variavel);
        $response->addDataSet($dtsVal);
    }

    public function getChecklist(DTO\Request $request, DTO\Response $response) {
        $variavel = $this->CardsService->buscandoChecklist();
        $dtsVal = new DataSet('checklist', $variavel);
        $response->addDataSet($dtsVal);
    }

    public function getItensChecklist(DTO\Request $request, DTO\Response $response) {
        $param = $request->getParameters();
        $variavel = $this->CardsService->buscandoItensChecklist($param);
        $dtsVal = new DataSet('tipoTarefa', $variavel);
        $response->addDataSet($dtsVal);
    }

    public function getFuncionario(DTO\Request $request, DTO\Response $response) {
        $variavel = $this->CardsService->buscandoFuncionario();
        $dtsVal = new DataSet('funcionario', $variavel);
        $response->addDataSet($dtsVal);
    }

    public function getCriterioTarefa(DTO\Request $request, DTO\Response $response) {
        $param = $request->getParameters();
        $variavel = $this->CardsService->buscandoCriterioTarefa($param);
        $dtsVal = new DataSet('criterioTarefa', $variavel);
        $response->addDataSet($dtsVal);
    }

    public function getTarefa(DTO\Request $request, DTO\Response $response) {
        $param = $request->getParameters();
        $variavel = $this->CardsService->buscandoTarefa($param);
        $dtsVal = new DataSet('tarefa', $variavel);
        $response->addDataSet($dtsVal);
    }
    
    public function getCriterioAtividade(DTO\Request $request, DTO\Response $response) {
        $param = $request->getParameters();
        $variavel = $this->CardsService->buscandoCriterioAtividade($param);
        $dtsVal = new DataSet('criterioTarefa', $variavel);
        $response->addDataSet($dtsVal);
    }
    
    public function getCard(DTO\Request $request, DTO\Response $response) {
        $param = $request->getParameters();
        $variavel = $this->CardsService->buscandoCard($param['variavel1']);
        $dtsVal = new DataSet('cards', $variavel);
        $response->addDataSet($dtsVal);
    }
    
    public function insertNovaTarefa(DTO\Request $request, DTO\Response $response) {
        $param = $request->getParameters();
        $variavel = $this->CardsService->insertNovaTarefa($param);
    }
}
?>