<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\FCMAnaliseConformidadeService;

class FCMAnaliseConformidadeController extends FMCrud{
  protected $FCMAnaliseConformidadeService;
  
  public function __construct($crudService, $environment, FCMAnaliseConformidadeService $FCMAnaliseConformidadeService) {
    parent::__construct($crudService, $environment);
    $this->FCMAnaliseConformidadeService = $FCMAnaliseConformidadeService;
  }

  public function getCriterioNaoConformidade(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();
    $variavel = $this->FCMAnaliseConformidadeService->getCriterioNaoConformidade($param);
    $dtsVal = new DataSet('criteriosConformidade', $variavel);
    $response->addDataSet($dtsVal);
  }

  public function getPrincipalNaoConformidade(DTO\Request $request, DTO\Response $response) {
    $param = $request->getParameters();
    $variavel = $this->FCMAnaliseConformidadeService->getPrincipalNaoConformidade($param);
    $dtsVal = new DataSet('principaisConformidade', $variavel);
    $response->addDataSet($dtsVal);
  }
}