<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class DashboardFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
    // requisição de retorno dos dados do dashboard Limpeza Finalizada
    public function getDadosLimpezaFinalizada() {
        
        $sql = "SELECT CA.NRCHECKLISTAGEND, CA.NRLOCALCLIENTE, CA.NRCHECKLIST, CA.NRFUNCIONARIO, CA.IDSITUACAOAGEND,
                  TO_CHAR(CA.DTHORAAGEND, 'DD/MM HH24:MI') DTHORAAGEND, LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI,
                  LCP.NMLOCALCLIENTE AS NMLOCALPAI, TO_CHAR(CA.DTULTATU, 'HH24:MI')DTULTATU, GCHK.NRGERENCIAMENTOCHK, GCHK.IDSITUACAOGERCHK
                        FROM FCM_CHECKLISTAGEND CA
                        JOIN FCM_LOCALCLI LC
                        ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                        JOIN FCM_LOCALCLI LCP
                        ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                        JOIN FCM_CHECKLIST CHK
                        ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                        JOIN FCM_FUNCIONARIO F
                        ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                        JOIN FCM_GERENCIAMENTOCHK GCHK
                        ON GCHK.NRCHECKLISTAGEND = CA.NRCHECKLISTAGEND
                        WHERE CA.IDSITUACAOAGEND = '4'
                        AND GCHK.IDSITUACAOGERCHK = '1'
                        AND TRUNC(SYSDATE) = TRUNC(CA.DTHORAAGEND)";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    // requisição de retorno dos dados do dashboard Tarefa Atrasada
    public function getDadosTarefaAtrasada() {
        
        $sql = "SELECT  NRCHECKLISTAGEND, NRLOCALCLIENTE, NRCHECKLIST, NRFUNCIONARIO, IDSITUACAOAGEND, DTHORAAGEND, NMLOCALCLIENTE, LOCALPAI, NMLOCALPAI, HORAS AS DTHORAATRASO
                 FROM ( SELECT CA.NRCHECKLISTAGEND, CA.NRLOCALCLIENTE, CA.NRCHECKLIST, CA.NRFUNCIONARIO, CA.IDSITUACAOAGEND,
                        TO_CHAR(CA.DTHORAAGEND, 'DD/MM HH24:MI') DTHORAAGEND, LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI,
                        LCP.NMLOCALCLIENTE AS NMLOCALPAI, TRUNC(SYSDATE - CA.DTHORAAGEND) * 24 + TRUNC(((SYSDATE - CA.DTHORAAGEND) - TRUNC (SYSDATE - CA.DTHORAAGEND)) * 24) AS HORAS,
                        TRUNC(((((SYSDATE - CA.DTHORAAGEND) - TRUNC(SYSDATE - CA.DTHORAAGEND)) * 24) - TRUNC(((SYSDATE - CA.DTHORAAGEND) - TRUNC(SYSDATE - CA.DTHORAAGEND)) *24))*60) AS MINUTOS
                              FROM FCM_CHECKLISTAGEND CA
                              JOIN FCM_LOCALCLI LC
                              ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                              JOIN FCM_LOCALCLI LCP
                              ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                              JOIN FCM_CHECKLIST CHK
                              ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                              JOIN FCM_FUNCIONARIO F
                              ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                              WHERE IDSITUACAOAGEND = '5') TAREFASATRASADAS";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    public function getDadosTarefaConcluida() {
        
        $sql = "SELECT CA.NRCHECKLISTAGEND, CA.NRLOCALCLIENTE, CA.NRCHECKLIST, CA.NRFUNCIONARIO, CA.IDSITUACAOAGEND,
                  TO_CHAR(CA.DTHORAAGEND, 'DD/MM HH24:MI') DTHORAAGEND, LC.NMLOCALCLIENTE, LC.NRLOCALCLIENTEPAI AS LOCALPAI,
                  LCP.NMLOCALCLIENTE AS NMLOCALPAI, TO_CHAR(CA.DTULTATU, 'HH24:MI')DTULTATU, GCHK.NRGERENCIAMENTOCHK, GCHK.IDSITUACAOGERCHK
                        FROM FCM_CHECKLISTAGEND CA
                        JOIN FCM_LOCALCLI LC
                        ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                        JOIN FCM_LOCALCLI LCP
                        ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                        JOIN FCM_CHECKLIST CHK
                        ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                        JOIN FCM_FUNCIONARIO F
                        ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                        JOIN FCM_GERENCIAMENTOCHK GCHK
                        ON GCHK.NRCHECKLISTAGEND = CA.NRCHECKLISTAGEND
                        WHERE CA.IDSITUACAOAGEND = '4'
                        AND GCHK.IDSITUACAOGERCHK = '3'
                        AND TRUNC(SYSDATE) = TRUNC(CA.DTHORAAGEND)";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    public function countTarefasConcluidas() {
      $sql = "SELECT COUNT(CA.NRCHECKLISTAGEND) AS QTDTAREFASCONCLUIDAS
                  FROM FCM_CHECKLISTAGEND CA
                  JOIN FCM_LOCALCLI LC
                  ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                  JOIN FCM_LOCALCLI LCP
                  ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                  JOIN FCM_CHECKLIST CHK
                  ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                  JOIN FCM_FUNCIONARIO F
                  ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                  JOIN FCM_GERENCIAMENTOCHK GCHK
                  ON GCHK.NRCHECKLISTAGEND = CA.NRCHECKLISTAGEND
                  WHERE CA.IDSITUACAOAGEND = '4'
                  AND GCHK.IDSITUACAOGERCHK = '3'
                  AND TRUNC(SYSDATE) = TRUNC(CA.DTHORAAGEND)";
      
      $std = $this->connection->prepare($sql);
        
      $std->execute();
      return $std->fetchAll();
    }
    
    public function countTarefas() {
      $sql = "SELECT COUNT(CA.NRCHECKLISTAGEND) AS QTDTAREFAS
                  FROM FCM_CHECKLISTAGEND CA
                  JOIN FCM_LOCALCLI LC
                  ON LC.NRLOCALCLIENTE = CA.NRLOCALCLIENTE
                  JOIN FCM_LOCALCLI LCP
                  ON LCP.NRLOCALCLIENTE = LC.NRLOCALCLIENTEPAI
                  JOIN FCM_CHECKLIST CHK
                  ON CA.NRCHECKLIST = CHK.NRCHECKLIST
                  JOIN FCM_FUNCIONARIO F
                  ON F.NRFUNCIONARIO = CA.NRFUNCIONARIO
                  WHERE TRUNC(SYSDATE) = TRUNC(DTHORAAGEND)";
      
      $std = $this->connection->prepare($sql);
        
      $std->execute();
      return $std->fetchAll();
    }
}