<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class FuncoesFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
   
    public function getPositionsFactory($params) {
        $sql = "SELECT NRPERFILACESSO, NMPERFILACESSO
                    FROM FCM_PERFILACESSO".$params;
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    public function positionsListFactory() {
        $sql = "SELECT NMPERFILACESSO, NRPERFILACESSO
                    FROM FCM_PERFILACESSO";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    public function createPositionFactory($params) {
        $sql = "INSERT INTO FCM_PERFILACESSO(NRPERFILACESSO, NMPERFILACESSO, IDPERMISSSUSUARIO, IDPERMISSSFUNCOES,
                                            IDPERMISSSTAREFAS, IDPERMISSSLOCAIS, IDPERMISSSCHECKLIST, IDPERMISSSRELATORIOS, 
                                            IDPERMISSSGRAFICOS, IDATIVO, DTINCLUSAO)
                        VALUES (:NRPERFILACESSO, :NMPERFILACESSO, :IDPERMISSSUSUARIO, :IDPERMISSSFUNCOES,
                                            :IDPERMISSSTAREFAS, :IDPERMISSSLOCAIS, :IDPERMISSSCHECKLIST, :IDPERMISSSRELATORIOS, 
                                            :IDPERMISSSGRAFICOS, :IDATIVO, SYSDATE)";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
    }
    
    public function getPositionInfoFactory($id) {
        $sql = "SELECT NRPERFILACESSO, NMPERFILACESSO, IDPERMISSSUSUARIO, IDPERMISSSFUNCOES,
                        IDPERMISSSTAREFAS, IDPERMISSSLOCAIS, IDPERMISSSCHECKLIST, IDPERMISSSRELATORIOS, 
                        IDPERMISSSGRAFICOS
                    FROM FCM_PERFILACESSO
                 WHERE NRPERFILACESSO = {$id}";
            
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    public function updatePositionFactory($params) {
        $sql = "UPDATE FCM_PERFILACESSO
                   SET NMPERFILACESSO = :NMPERFILACESSO,
                       IDPERMISSSUSUARIO = :IDPERMISSSUSUARIO,
                       IDPERMISSSFUNCOES = :IDPERMISSSFUNCOES,
                       IDPERMISSSTAREFAS = :IDPERMISSSTAREFAS,
                       IDPERMISSSLOCAIS = :IDPERMISSSLOCAIS,
                       IDPERMISSSCHECKLIST = :IDPERMISSSCHECKLIST,
                       IDPERMISSSRELATORIOS = :IDPERMISSSRELATORIOS,
                       IDPERMISSSGRAFICOS = :IDPERMISSSGRAFICOS
                 WHERE NRPERFILACESSO = :NRPERFILACESSO";
                
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }
    
    public function deletePositionsFactory($params) {
        $sql = "DELETE FROM FCM_PERFILACESSO
                 WHERE NRPERFILACESSO = :NRPERFILACESSO";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
    }
    
    public function validPositionsInRelacFuncFactory($params) {
        $sql = "SELECT COUNT (*) AS VALIDA
                    FROM FCM_RELACFUNCPERFACESS
                 WHERE NRPERFILACESSO = :NRPERFILACESSO";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        return $std->fetchAll();
    }
}
?>