<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class NewLocalFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
   
    public function getFactoryCheckList() {
        $sql = "SELECT NRCHECKLIST, NMCHECKLIST
                  FROM FCM_CHECKLIST";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute();
        return $std->fetchAll();
    }
    
    public function insertFactoryLocal($param) {
        $sql = "INSERT INTO FCM_TIPOLOCALCLI
                VALUES(:NRTIPOLOCALCLI, :NMTIPOLOCALCLI, :IDTIPOLOCALCLI, :NRCHECKLISTPADR, :DSICONETIPOLOCAL, :IDATIVO, :NRORG, SYSDATE, :CDOPERINCLUSAO, :NRORGINCLUSAO, :DTULTATU, :CDOPERULTATU, :NRORGULTATU, :DSTIPOLOCALCLI)";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($param);
    }
    
    public function getFactoryLocalToUpdate($param) {
        $sql = "SELECT NRTIPOLOCALCLI, NMTIPOLOCALCLI, IDTIPOLOCALCLI, NRCHECKLISTPADR
                  FROM FCM_TIPOLOCALCLI
                WHERE NRTIPOLOCALCLI = :NRTIPOLOCALCLI";
        
        $std = $this->connection->prepare($sql);
        
        //Talvez depois testa comentar essa linha caso de erro
        $std->execute($param);
        return $std->fetchAll();
    }
    
    public function updateFactoryLocal($param) {
        $sql = "UPDATE FCM_TIPOLOCALCLI
                    SET NRTIPOLOCALCLI = :NRTIPOLOCALCLI,
                        NMTIPOLOCALCLI = :NMTIPOLOCALCLI,
                        IDTIPOLOCALCLI = :IDTIPOLOCALCLI,
                        NRCHECKLISTPADR = :NRCHECKLISTPADR,
                        DTINCLUSAO = SYSDATE
                WHERE NRTIPOLOCALCLI = :NRTIPOLOCALCLI";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($param);
    }
}
?>