<?php
namespace FM\Factory;

use Doctrine\ORM\EntityManager;

class VistoriasFactory {
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        
        $this->connection = $entityManager->getConnection();
    }
   
   // Busca nome e local da vistoria
   public function getInspectionNameAndLocal($params) {
        $sql = "SELECT A.NMGERENCIAMENTOCHK, A.NRGERENCIAMENTOCHK, B.NMLOCALCLIENTE
                    FROM FCM_GERENCIAMENTOCHK A
                        INNER JOIN FCM_LOCALCLI B ON B.NRLOCALCLIENTE = A.NRLOCALCLIENTE
                 WHERE A.NRGERENCIAMENTOCHK = {$params}";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
   // Busca e filtra vistorias
    public function getInspectionsInfo($params) {
        $sql = "SELECT A.NMGERENCIAMENTOCHK, A.NRGERENCIAMENTOCHK, B.NMLOCALCLIENTE, D.NMLOCALCLIENTE AS NMLOCALCLIENTEPAI,
                        A.DTHORAAGEND, NMFUNCIONARIO, A.NRCHECKLISTAGEND, CASE A.IDSITUACAOGERCHK
                            WHEN '1' THEN 'Aguardando Avaliação'
                            WHEN '2' THEN 'Em Andamento'
                            WHEN '3' THEN 'Concluido'
                            WHEN '4' THEN 'Cancelado'
                            ELSE NULL END AS IDSITUACAOGERCHK
                    FROM FCM_GERENCIAMENTOCHK A
                        INNER JOIN FCM_LOCALCLI B ON B.NRLOCALCLIENTE = A.NRLOCALCLIENTE
                        INNER JOIN FCM_FUNCIONARIO C ON C.NRFUNCIONARIO = A.NRFUNCIONARIO
                        INNER JOIN FCM_LOCALCLI D ON D.NRLOCALCLIENTE = B.NRLOCALCLIENTEPAI 
                        JOIN FCM_CHECKLISTAGEND E ON E.NRCHECKLISTAGEND = A.NRCHECKLISTAGEND 
                                                    AND E.IDSITUACAOAGEND = 4".$params['FILTER'];
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    // Busca critérios
    public function getCriteria($params) {
        $sql = "SELECT NRCRITERIOTARGERCHK, NMCRITERIOTARGERCHK, IDMARCADO
                    FROM FCM_CRITERIOTARGERCHK
                 WHERE NRTAREFAGERCHK = {$params}";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    // Busca Observações
    public function getInspectionToUpdate($params) {
        $sql = " SELECT A.NRTAREFAGERCHK, A.NRGERENCIAMENTOCHK, A.DSOBSTAREFAGERCHK
                      FROM FCM_TAREFAGERCHK A
                          JOIN FCM_TAREFACHK B
                            ON B.NRTAREFACHK = A.NRTAREFACHK
                         WHERE A.NRGERENCIAMENTOCHK = :NRGERENCIAMENTOCHK
                           AND B.NRATIVIDADECHK = :NRATIVIDADECHK";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        return $std->fetchAll();
    }
    
    // Busca Atividades
    public function getActivities($id) {
        $sql = "SELECT DISTINCT A.NRATIVIDADECHK, B.NMATIVIDADE
                    FROM FCM_ATIVIDADECHK A
                    JOIN FCM_ATIVIDADE B
                        ON B.NRATIVIDADE = A.NRATIVIDADE
                    JOIN FCM_TAREFACHK C
                        ON C.NRATIVIDADECHK = A.NRATIVIDADECHK
                        AND NRTAREFACHK IN (SELECT NRTAREFACHK 
                                                FROM FCM_TAREFAGERCHK  
                                             WHERE NRGERENCIAMENTOCHK = {$id})";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute();
        return $std->fetchAll();
    }
    
    // Insere um novo critério
    public function insertCriterio($params) {
        $sql = "INSERT INTO FCM_CRITERIOTARGERCHK  (NRCRITERIOTARGERCHK, NRTAREFAGERCHK, IDATIVO, 
                                                    DTINCLUSAO, NMCRITERIOTARGERCHK, IDMARCADO)
                    VALUES (:NRCRITERIOTARGERCHK, :NRTAREFAGERCHK, 'S', SYSDATE, :NMCRITERIOTARGERCHK, 'S')";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        
    }
  
    // Atualiza o campo IDMARCADO do critério para S ou N
    public function updateCriterio($params) {
        $sql = "UPDATE FCM_CRITERIOTARGERCHK
                   SET IDMARCADO = :IDMARCADO,
                       DTULTATU = SYSDATE
                 WHERE NRCRITERIOTARGERCHK = :NRCRITERIOTARGERCHK
                    AND NRTAREFAGERCHK  = :NRTAREFAGERCHK";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        
    }
    
    // Atualiza o campo de observação da vistoria
    public function updateNote($params) {
        $sql = "UPDATE FCM_TAREFAGERCHK
                   SET DSOBSTAREFAGERCHK = :DSOBSTAREFAGERCHK,
                       DTULTATU = SYSDATE
                 WHERE NRTAREFAGERCHK = :NRTAREFAGERCHK
                    AND NRGERENCIAMENTOCHK = :NRGERENCIAMENTOCHK";
        
        $std = $this->connection->prepare($sql);
        
        $std->execute($params);
        
    }
}
?>